unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, AdCalc, Menus, ExtCtrls;

type
  TMainForm = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Edit2: TEdit;
    Label6: TLabel;
    Button8: TButton;
    Button9: TButton;
    AdCalc1: TAdCalc;
    Memo2: TMemo;
    Label7: TLabel;
    Panel1: TPanel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label4: TLabel;
    ListBox1: TListBox;
    Panel2: TPanel;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Label5: TLabel;
    ListBox2: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AdCalc1GetBooleanVar(Sender: TObject; VarName: String;
      var Found, Value: Boolean);
    procedure AdCalc1GetExtendedVar(Sender: TObject; VarName: String;
      var Found: Boolean; var Value: Extended);
    procedure AdCalc1GetExtendedFunct(Sender: TObject; FunctName: String;
      var Found: Boolean; var Value: Extended);
    procedure AdCalc1GetBooleanFunct(Sender: TObject; FunctName: String;
      var Found, Value: Boolean);
    procedure Button2Click(Sender: TObject);
    procedure AdCalc1FunctList(Sender: TObject; FunctName: String;
      FunctType: TExprType; Formula: TStrings; Params: array of TExprType);
    procedure Button3Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    function GetVarName:string;
    procedure AdCalc1VarList(Sender: TObject; VarName: String;
      VarType: TExprType; Value: Pointer);
    procedure Button6Click(Sender: TObject);
    procedure ListBox2DblClick(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure AdCalc1FunctError(Sender: TObject; FunctName: String;
      ErrorLine, ErrorPosition, ErrorPlace, ErrorCode: Integer;
      ErrorStr: String);
    procedure AdCalc1Error(Sender: TObject; ErrorLine, ErrorPosition,
      ErrorPlace, ErrorCode: Integer; ErrorStr: String; Handle: integer);
  private
    { Private declarations }
    procedure ApplyFunction;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses AddF, AddV, SetV;

{$R *.DFM}

procedure TMainForm.Button1Click(Sender: TObject);
var
  n:Extended;
begin
  Label1.Caption:='';
  ActiveControl:=Memo1;
  if AdCalc1.GetBlockResult(Memo2.Lines,0) then begin
    if AdCalc1.GetExtendedResult(Memo1.Lines,n,1) then begin
      Label1.Caption:='Result= '+FloatToStr(n);
      Memo1.SelectAll;
    end;
    ListBox2.Items.Clear;
    AdCalc1.GetVarList;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Memo1.WordWrap:=false; {Is necessary for correct returning of error place}
  Memo2.WordWrap:=false;
  ActiveControl:=Memo1;
  with AdCalc1 do begin
    {The method declares function, which is determined in
    event OnGetFunct at design-time}
    DefExtendedFunct('Max',[expExtended,expExtended]);
    DefBooleanFunct('IsEqual',[expExtended,expExtended]);
    AdCalc1.LoadLibrary('Demo.acl');
  end;
  ListBox1.Items.Clear;
  AdCalc1.GetFunctList;
  ListBox2.Items.Clear;
  AdCalc1.GetVarList;
end;

procedure TMainForm.AdCalc1GetBooleanVar(Sender: TObject; VarName: String;
  var Found, Value: Boolean);
var
  Formula:TStrings;
begin
  if VarName=LowerCase('MyBooleanVar') then begin
    Formula:=TStringList.Create;
    Formula.Clear;
    Formula.Add(Edit2.Text);
    try
      Found:=AdCalc1.GetBooleanResult(Formula,Value,3);
    finally
      Formula.Destroy;
    end;
  end;
end;

procedure TMainForm.AdCalc1GetExtendedVar(Sender: TObject; VarName: String;
  var Found: Boolean; var Value: Extended);
var
  Formula:TStrings;
begin
  if VarName=LowerCase('MyExtendedVar') then begin
    Formula:=TStringList.Create;
    Formula.Clear;
    Formula.Add(Edit1.Text);
    try
      Found:=AdCalc1.GetExtendedResult(Formula,Value,2);
    finally
      Formula.Destroy;
    end;
  end;
end;

procedure TMainForm.AdCalc1GetExtendedFunct(Sender: TObject;
  FunctName: String; var Found: Boolean; var Value: Extended);
begin
  if FunctName=LowerCase('Max') then with AdCalc1 do begin
    Found:=true;
    if extended(GetParam(1)^)>extended(GetParam(2)^) then
      Value:=extended(GetParam(1)^)
    else Value:=extended(GetParam(2)^);
  end;
end;

procedure TMainForm.AdCalc1GetBooleanFunct(Sender: TObject; FunctName: String;
  var Found, Value: Boolean);
var
  p1,p2:pointer;
begin
  if FunctName=LowerCase('IsEqual') then with AdCalc1 do begin
    p1:=GetParam(1);
    p2:=GetParam(2);
    if (p1<>nil)and(p2<>nil) then begin
      Found:=true;
      Value:=extended(p1^)=extended(p2^);
    end;
  end;
end;

procedure TMainForm.ApplyFunction;
var
  FParams:array of TExprType;
  i:integer;
begin
  with AddFunct do begin
    if Edit1.Text='' then begin
      ShowMessage('Function name missing');
      Exit;
    end;
    if Memo1.Lines.Count=0 then begin
      ShowMessage('Function expression missing');
      Exit;
    end;
    SetLength(FParams,ListBox1.Items.Count);
    with ListBox1 do for i:=0 to Items.Count-1 do begin
      if Items[i]=ComboBox2.Items[0] then FParams[i]:=expExtended;
      if Items[i]=ComboBox2.Items[1] then FParams[i]:=expBoolean;
    end;
    if FParams<>nil then case ComboBox1.ItemIndex of
      {The method declares function, which is determined
      in field "Formula" at run-time}
      0:MainForm.AdCalc1.RegExtendedFunct(Edit1.Text,FParams,Memo1.Lines);
      1:MainForm.AdCalc1.RegBooleanFunct (Edit1.Text,FParams,Memo1.Lines);
    end
    else begin
      ShowMessage('Function parameters missing');
      Exit;
    end;
    MainForm.ListBox1.Items.Clear;
    AdCalc1.GetFunctList;
  end;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  with AddFunct do begin
    ClearFields;
    Caption:='Add function';
    ShowModal;
    if ModalResult=mrOk then ApplyFunction;
  end;
end;

procedure TMainForm.AdCalc1FunctList(Sender: TObject; FunctName: String;
  FunctType: TExprType; Formula: TStrings; Params: array of TExprType);
begin
  ListBox1.Items.Add(UpperCase(FunctName));
end;

procedure TMainForm.Button3Click(Sender: TObject);
var
  FN:string;
  FT:TExprType;
  Formula:TStrings;
  i:integer;
begin
  try
    AddFunct.ClearFields;
    Formula:=TStringList.Create;
    if (ListBox1.ItemIndex>-1)and(ListBox1.Items.Count>0) then begin
      FN:=ListBox1.Items[ListBox1.ItemIndex];
      if AdCalc1.GetFunctPropertys(FN,FT,Formula) then with AddFunct do begin
        Caption:='Edit function';
        Edit1.Text:=FN;
        Edit1.Enabled:=false;
        case FT of
          expExtended : ComboBox1.ItemIndex:=0;
          expBoolean  : ComboBox1.ItemIndex:=1;
        end;
        Memo1.Lines.Clear;
        for i:=0 to Formula.Count-1 do
          Memo1.Lines.Add(Formula[i]);
        ListBox1.Clear;
        for i:=0 to High(AdCalc1.FunctParams) do
          {Dinamic array Variable "FunctParams" accepts values of
          parameters of the given function. This is used only after
          call of function "GetFunctPropertys"}
          case AdCalc1.FunctParams[i] of
            expExtended : ListBox1.Items.Add(ComboBox2.Items[0]);
            expBoolean  : ListBox1.Items.Add(ComboBox2.Items[1]);
          end;
        ShowModal;
        if ModalResult=mrOk then ApplyFunction;
      end;
    end;
  finally
    Formula.Destroy;
  end;
end;

procedure TMainForm.ListBox1DblClick(Sender: TObject);
begin
  Button3Click(Sender);
end;

procedure TMainForm.Button4Click(Sender: TObject);
var
  i:integer;
begin
  with ListBox1 do if (ItemIndex>-1)and
    (ListBox1.Items.Count>0) then with AdCalc1 do begin
    if MessageDlg('Are you sure to delete function "'+
      UpperCase(ListBox1.Items[ListBox1.ItemIndex])+'"',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
      RemoveFunct(Items[ItemIndex]);
      i:=ListBox1.ItemIndex;
      ListBox1.Items.Clear;
      GetFunctList;
      if i>ListBox1.Items.Count-1 then
        ListBox1.ItemIndex:=ListBox1.Items.Count-1
      else ListBox1.ItemIndex:=i;
    end;
  end;
end;

procedure TMainForm.Button5Click(Sender: TObject);
begin
  with AddVar do begin
    ActiveControl:=Edit1;
    Edit1.Text:='';
    ShowModal;
    if ModalResult=mrOk then begin
      case ComboBox1.ItemIndex of
        0:AdCalc1.RegVariable(Edit1.Text,expExtended);
        1:AdCalc1.RegVariable(Edit1.Text,expboolean);
      end;
      ListBox2.Items.Clear;
      AdCalc1.GetVarList;
    end;
  end;
end;

function TMainForm.GetVarName:string;
var
  i:integer;
begin
  Result:='';
  with ListBox2 do if (ItemIndex>-1)and
    (ListBox1.Items.Count>0) then begin
    i:=1;
    while (Items[ItemIndex][i]<>#32)and
          (i<=Length(Items[ItemIndex])) do begin
      Result:=Result+Items[ItemIndex][i];
      inc(i);
    end;
  end;
end;

procedure TMainForm.Button7Click(Sender: TObject);
var
  i:integer;
  VN:string;
begin
  VN:=GetVarName;
  if VN<>'' then with AdCalc1 do begin
    if MessageDlg('Are you sure to delete variable "'+VN+'"',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
      RemoveVar(VN);
      i:=ListBox2.ItemIndex;
      ListBox2.Items.Clear;
      GetVarList;
      if i>ListBox2.Items.Count-1 then
        ListBox2.ItemIndex:=ListBox2.Items.Count-1
      else ListBox2.ItemIndex:=i;
    end;
  end;
end;

procedure TMainForm.AdCalc1VarList(Sender: TObject; VarName: String;
  VarType: TExprType; Value: Pointer);
const
  BoolWords: array[Boolean] of string = ('False', 'True');
var
  vs:string;
begin
  vs:='No value';
  case VarType of
    expExtended:if Value<>nil then vs:=FloatToStr(extended(Value^));
    expBoolean :if Value<>nil then vs:=BoolWords[boolean(Value^)];
  end;
  ListBox2.Items.Add(UpperCase(VarName)+' = '+vs);
end;

procedure TMainForm.Button6Click(Sender: TObject);
const
  BoolWords: array[Boolean] of string = ('False', 'True');
var
  VN:string;
  VT:TExprType;
  Value:pointer;
  EV:extended;
  BV:boolean;
  Formula:TStrings;
begin
  VN:=GetVarName;
  if VN<>'' then begin
    if AdCalc1.GetVarPropertys(VN,VT,Value) then with SetVar do begin
      Label4.Caption:=VN;
      Edit1.Text:='';
      case VT of
        expExtended:begin
          Label5.Caption:='Extended';
          Label7.Caption:=FloatToStr(extended(Value^));
        end;
        expBoolean :begin
          Label5.Caption:='Boolean';
          Label7.Caption:=BoolWords[boolean(Value^)];
        end;
      end;
      ShowModal;
      if (ModalResult=mrOk)and(Edit1.Text<>'') then begin
        Formula:=TStringList.Create;
        Formula.Clear;
        Formula.Add(Edit1.Text);
        try
          case VT of
            expExtended:begin
              if AdCalc1.GetExtendedResult(Formula,EV,4) then
                AdCalc1.SetExtendedVarValue(VN,EV);
            end;
            expBoolean :begin
              if AdCalc1.GetBooleanResult(Formula,BV,4) then
                AdCalc1.SetBooleanVarValue(VN,BV);
            end;
          end;
          ListBox2.Items.Clear;
          AdCalc1.GetVarList;
        finally
          Formula.Destroy;
        end;
      end;
    end;
  end;
end;

procedure TMainForm.ListBox2DblClick(Sender: TObject);
begin
  Button6Click(Sender);
end;

procedure TMainForm.Button8Click(Sender: TObject);
begin
  with Opendialog1 do begin
    FileName:='';
    if Execute then begin
      AdCalc1.LoadLibrary(FileName);
      ListBox1.Items.Clear;
      AdCalc1.GetFunctList;
      ListBox2.Items.Clear;
      AdCalc1.GetVarList;
    end;
  end;
end;

procedure TMainForm.Button9Click(Sender: TObject);
var
  Ext:string;
begin
  with SaveDialog1 do begin
    FileName:='';
    if Execute then begin
      Ext:=ExtractFileExt(FileName);
      if Ext='' then Ext:='.acl'
      else Ext:='';
      AdCalc1.SaveLibrary(FileName+Ext);
    end;
  end;
end;

procedure TMainForm.AdCalc1FunctError(Sender: TObject; FunctName: String;
  ErrorLine, ErrorPosition, ErrorPlace, ErrorCode: Integer;
  ErrorStr: String);
begin
  ShowMessage('Function - "'+UpperCase(FunctName)+
    '"; Line - '+IntToStr(ErrorLine)+
    '; Col - '+IntToStr(ErrorPosition)+'; '+ErrorStr);
end;

procedure TMainForm.AdCalc1Error(Sender: TObject; ErrorLine, ErrorPosition,
  ErrorPlace, ErrorCode: Integer; ErrorStr: String; Handle: integer);
begin
  case Handle of
    0:begin
      ActiveControl:=Memo2;
      Label1.Caption:='Error '+IntToStr(ErrorCode)+', Line '+
        IntToStr(ErrorLine)+', '+ErrorStr;
      Memo2.SelStart:=ErrorPlace;
    end;
    1:begin
      Label1.Caption:='Error '+IntToStr(ErrorCode)+', Line '+
        IntToStr(ErrorLine)+', '+ErrorStr;
      Memo1.SelStart:=ErrorPlace;
    end;
    2:begin
      ShowMessage(ErrorStr+'; Col - '+IntToStr(ErrorPlace));
      ActiveControl:=Edit1;
      Edit1.SelStart:=ErrorPosition;
    end;
    3:begin
      ShowMessage(ErrorStr+'; Col - '+IntToStr(ErrorPlace));
      ActiveControl:=Edit2;
      Edit2.SelStart:=ErrorPosition;
    end;
    4:begin
      ShowMessage(ErrorStr+'; Col - '+IntToStr(ErrorPlace));
    end;
  end;
end;

end.
