unit PxCGIExpertOptimizer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  PxOptimizer,genEng;

type
//CE_Desc_Begin(TPxCGIExpertOptimizer)
{The PxCGIExpertOptimzer is the most advanced optimizer of the two, and the most simple to use.
Just define which CGIexpert engine should be used by setting the CGIExpertEnging property, and Pixelpack will take care of the rest.

The CGIexpert engine is used by Pixelpack to determine browser type and mozilla version automatically.}
//CE_Desc_End

  OptimizeForType = (ofSize,ofAccuracy);

  TPxCGIExpertOptimizer = class(TPxCustomOptimizer)
  private
    { Private declarations }
    m_engine : TGeneralHttpEngine;
    initialized : boolean;
    m_optimizeFor : OptimizeForType;
    procedure parseUserAgent;
  protected
    { Protected declarations }
    function  getBrowserType : t_browser; override;
    function  getUseCSS : boolean; override;
    function  getoptimizeTableDefinitions : boolean; override;
    function  getUseClearPixel : boolean; override;

  public
    { Public declarations }
    procedure reset; override;
    constructor create( AOwner : TComponent);
  published
    { Published declarations }
//CE_Desc_Begin(TPxCGIExpertOptimizer.CGIExpertEngine)
{Use this property to define the CGIExpert engine that shall be used to extract browser information. Typically, you will only have one engine per project.}
//CE_Desc_End
    property CGIExpertEngine : TGeneralHttpEngine read m_engine write m_engine;
    property OptimizeFor : optimizeforType read m_optimizeFor write m_optimizefor;

  end;

procedure Register;

implementation

constructor TPxCGIExpertOptimizer.create( AOwner : TComponent);
begin
     inherited create(AOwner);
     initialized:=false;
end;

procedure TPxCGIExpertOptimizer.reset;
begin
     inherited reset;
     initialized:=false;
end;

function TPxCGIExpertOptimizer.getUseClearPixel : boolean;
begin
     ParseUserAgent;
     if (m_browserType=brNavigator) and (m_optimizeFor=ofAccuracy) then
        result:=true
     else
        result:=false;
end;


function TPxCGIExpertOptimizer.getBrowserType : t_browser;
begin
     parseUserAgent;
     result:= inherited getBrowserType;
end;
function TPxCGIExpertOptimizer.getUseCSS : boolean;
begin
     parseUserAgent;
     result:= inherited getUseCSS;

end;

function TPxCGIExpertOptimizer.getoptimizeTableDefinitions : boolean;
begin
     parseUserAgent;
     result:= inherited getoptimizeTableDefinitions;
end;

procedure TPxCGIExpertOptimizer.parseUserAgent;
var
   s,t : string;
   i : integer;
begin
     if (CGIExpertEngine<>nil) and (initialized=false)  then
     begin
          initialized:=true;
          s:=uppercase(CGIExpertEngine.useragent);

          // determine browser type
          if pos('WEBTV',s)>0 then m_browserType:=brWebTV else
          if pos('MSIE',s)>0 then m_browserType:=brExplorer else
          if pos('OPERA',s)>0 then m_browserType:=brOpera else
          if pos(' I)',s)>0 then m_browserType:=brNavigator else
          if pos(' I;',s)>0 then m_browserType:=brNavigator else
          if pos(' I ',s)>0 then m_browserType:=brNavigator else
             m_browsertype:=brUnknown;

          // determine mozilla version
          i:=pos('MOZILLA/',s);
          if i>0 then
          begin
             delete(s,1,i+length('MOZILLA/')-1);
             t:=copy(s,1,3);
             try
                DecimalSeparator:='.';
                m_mozillaVersion:=strtofloat(t);
             except
                m_mozillaVersion:=-1;
             end;

          end
          else
              m_mozillaVersion:=-1;

          // if navigator, then disable optimal tables ( because of bug in Navigator ..sic )
          if m_browserType=brNavigator then
             m_optimizeTableDefinitions:=false
          else
             m_optimizeTableDefinitions:=True;

          // check if browser can show CSS
          if ((m_browserType=brNavigator) and (m_mozillaVersion>=4.0))
              or
             ((m_browserType<>brNavigator) and (m_mozillaVersion>=2.0))then
             m_useCSS:=true
             else
             m_useCSS:=false;


          // better safe than sorry
          if m_browserType=brUnknown then m_UseCSS:=false;

          
     end
     else
     if (CGIExpertEngine=nil) then
     begin
          m_UseCSS:=false;
          m_optimizeTableDefinitions:=false;
          m_browserType:=brUnknown;
          m_mozillaVersion:=-1;


     end;

end;

procedure Register;
begin
  RegisterComponents('PixelPack', [TPxCGIExpertOptimizer]);
end;

end.
