unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, DBCtrls, Grids, DBGrids, Db;

type
  TMainForm = class(TForm)
    dsCust: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    chAutoPost: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    cbFields: TComboBox;
    cmApply: TButton;
    cmCancel: TButton;
    chSortNoCase: TCheckBox;
    chSortDesc: TCheckBox;
    cmSort: TButton;
    procedure FormShow(Sender: TObject);
    procedure chAutoPostClick(Sender: TObject);
    procedure dsCustStateChange(Sender: TObject);
    procedure cmSortClick(Sender: TObject);
    procedure cmApplyClick(Sender: TObject);
    procedure cmCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses dMain, vgDBUtl, vgCDS;

{$R *.DFM}

procedure TMainForm.FormShow(Sender: TObject);
begin
  dsCust.DataSet.Open;
end;

procedure TMainForm.chAutoPostClick(Sender: TObject);
begin
  dm.cdCust.AutoPost := chAutoPost.Checked;
end;

procedure TMainForm.dsCustStateChange(Sender: TObject);
begin
  if dsCust.State = dsBrowse then
    GetSQLFieldNames(dsCust.DataSet, cbFields.Items);
end;

procedure TMainForm.cmSortClick(Sender: TObject);
var
  S: string;
begin
  S := cbFields.Text;
  if (Pos(';', S) = 0) and (Pos('@', S) = 0) then
  begin
    if chSortDesc.Checked then
      S := S + ooDesc;
    if chSortNoCase.Checked then
      S := S + ooNoCase;
  end;
  dm.cdCust.IndexFieldNamesEx := S;
end;

procedure TMainForm.cmApplyClick(Sender: TObject);
begin
  dm.cdCust.ApplyUpdates(-1);
end;

procedure TMainForm.cmCancelClick(Sender: TObject);
begin
  dm.cdCust.CancelUpdates ;
end;

end.
