{*******************************************************}
{                                                       }
{         Vladimir Gaitanoff Delphi VCL Library         }
{         TProviderListEditor                           }
{                                                       }
{         Copyright (c) 1997, 1999                      }
{                                                       }
{*******************************************************}

{$I VG.INC }

unit vgProvEd;

interface

uses
  Classes, Graphics, Controls, Forms, vgItems, Menus, StdCtrls, DsgnIntf;

type
{ TProviderListEditorForm }
  TProviderListEditorForm = class(TItemsEditorForm)
  private
    procedure NewProviderItem(ItemClass: TComponentClass);
  public
    procedure GetVerb(Index: Integer; var Caption: TCaption; var ShortCut: TShortCut); override;
    function GetVerbCount: Integer; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

{ TProviderListEditor }
  TProviderListEditor = class(TItemsEditor)
  public
    function GetFormClass: TItemsEditorFormClass; override;
  end;

implementation
uses DBConsts, BDEConst, SysUtils, DB, DBTables, vgProvid, vgBDEPrv;

{ TProviderListEditor }
function TProviderListEditor.GetFormClass: TItemsEditorFormClass;
begin
  Result := TProviderListEditorForm;
end;

const
{$IFDEF _D4_}
  NewVerbCount = 2;
{$ELSE}
  NewVerbCount = 1;
{$ENDIF}

{ TProviderListEditorForm }
procedure TProviderListEditorForm.GetVerb(Index: Integer; var Caption: TCaption; var ShortCut: TShortCut);
begin
  case Index of
    0:
      begin
        Caption := '&New ProviderItem...';
        ShortCut := Menus.ShortCut(ord('N'), [ssCtrl]);
      end;
  {$IFDEF _D4_}
    1:
      begin
        Caption := 'New &DataSetProviderItem...';
        ShortCut := Menus.ShortCut(ord('D'), [ssCtrl]);
      end;
  {$ENDIF}
  else
    inherited GetVerb(Index - NewVerbCount, Caption, ShortCut);
  end;
end;

{ TConverterEditorForm }
function TProviderListEditorForm.GetVerbCount: Integer;
begin
  Result := inherited GetVerbCount + NewVerbCount;
end;

procedure TProviderListEditorForm.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: if ItemList is TProviderList then
         NewProviderItem(TProviderItem);
  {$IFDEF _D4_}
    1: NewProviderItem(TDataSetProviderItem);
  {$ENDIF}
  else
    inherited ExecuteVerb(Index - NewVerbCount);
  end;
end;

procedure TProviderListEditorForm.NewProviderItem(ItemClass: TComponentClass);
var
  Item: TCustomProviderItem;
begin
  Item := TCustomProviderItem(Designer.CreateComponent(ItemClass, TCustomProviderList(ItemList), 0, 0, 0, 0));
  try
    Item.DesignInfo := 0;
    TCustomProviderItem(Item).ProviderList := TCustomProviderList(ItemList);
    Designer.Modified;
  except
    Item.Free;
    raise;
  end;
end;

end.
